
def load_file(filename):
    f = open(filename)
    sites4rna = {}
    for row in f:
        data = row.split()
        if sites4rna.has_key(data[0]):
            sites4rna[data[0]].append((int(data[1]),int(data[2])))
        else:
            sites4rna[data[0]] = [(int(data[1]),int(data[2]))]
    f.close()
    return sites4rna


def merge_sites(sites1, sites2, thres):
    sites = []
    for (beg1, end1) in sites1:
        for (beg2, end2) in sites2:
            beg = max(beg1, beg2)
            end = min(end1, end2)
            if end - beg >= thres:
                sites.append((beg, end))
            break
    return sites

def combine_replicates(sites4rna1, sites4rna2, thres):
    sites4rna = {}
    for rna in sites4rna1.keys():
        if sites4rna2.has_key(rna):
            sites = merge_sites(sites4rna1[rna], sites4rna2[rna], thres)
            if sites:
                sites4rna[rna] = sites
    return sites4rna

def print_sites4rna(sites4rna):
    for rna,sites in sites4rna.items():
        print "".join(["%s\t%d\t%d\n" % (rna,beg,end) for (beg,end) in sites])


filename1 = raw_input("Nome file prima replica: ") 
filename2 = raw_input("Nome file seconda replica: ") 
thres = int(raw_input("Soglia su lunghezza sito: "))

sites4rna1 = load_file(filename1)
sites4rna2 = load_file(filename2)

print_sites4rna(combine_replicates(sites4rna1, sites4rna2, thres))
