

def load_go(filename):
	f = open(filename)
	go2seqid = {}

	for row in f:
		if row.startswith("!"):
			continue
		data = row.split()
		go = data[3]
		seqid = data[1]
		if not go in go2seqid:
			go2seqid[go]=[seqid]
		else:
			go2seqid[go].append(seqid)

	f.close()

	return go2seqid

def load_seqs(filename):
	f = open(filename)
	name2seq = {}
	name = ""
	seq = ""

	for row in f:
		if row.startswith(">"):
			if name:
				name2seq[name]=seq				
			name=row.split("|")[1]
			seq=""
		else:
			seq+=row.strip()

	if name:
			name2seq[name]=seq

	return name2seq


def composition(seq):
	histo={}

	for el in seq:
		if not el in histo:
			histo[el]=1
		else:
			histo[el]+=1

	for el in histo:
		histo[el] /= float(len(seq))

	return histo

def go_composition(go2seq, name2seq):

	for (term, names) in go2seq.items():
		print(term)		
		print(composition("".join([name2seq[name] for name in names])))


gofile = input("nome file GO: ")
seqfile = input("nome file Fasta: ")

go2seq = load_go(gofile)
name2seq = load_seqs(seqfile)

go_composition(go2seq, name2seq)